--
-- FastNightGui
-- V1.0.0.0
--
-- @author apuehri
-- @date 06/05/2018
--
-- Copyright (C) apuehri
-- V1.0.0.0 ..... first implementation

fnGui = {};

local fnGui_mt = Class(fnGui, ScreenElement);

function fnGui:new(target, custom_mt)
    local self = ScreenElement:new(target, fnGui_mt);
    self.returnScreenName = "";
    return self;	
end

function fnGui:onOpen()
    fnGui:superClass().onOpen(self);
	FocusManager:setFocus(self.backButton);
end

function fnGui:onClose()
    fnGui:superClass().onClose(self);
end

function fnGui:onClickBack()
    fnGui:superClass().onClickBack(self);
	fastnight:updGui();
end

function fnGui:onClickOk()
    fnGui:superClass().onClickOk(self);
	fastnight:settingsFromGui(self.sdh:getState(), self.sdm:getState(), self.dts:getState(), self.adts:getIsChecked(), self.snh:getState(), self.snm:getState(), self.nts:getState(), self.ants:getIsChecked());
    self:onClickBack();
end

function fnGui:onFocusElement(element)
    if element.toolTip ~= nil then
        self:setHelpBoxText(element.toolTip);
    end
end

function fnGui:onLeaveElement(element)
	self:setHelpBoxText("");
end

function fnGui:setHelpBoxText(text)
    self.ingameMenuHelpBoxText:setText(text);
    self.ingameMenuHelpBox:setVisible(text ~= "");
end

function fnGui:onCreateStartDayHour(element)
    self.sdh = element;
    local hour = {};

    for i = 1, #fastnight.hourSteps, 1 do
        hour[i] = ""..tostring(fastnight.hourSteps[i]).. " h";
    end
    element:setTexts(hour);
end

function fnGui:onCreateStartDayMinute(element)
    self.sdm = element;
    local minute = {};

    for i = 1, #fastnight.minuteSteps, 1 do
        minute[i] = ""..tostring(fastnight.minuteSteps[i]).. " m";
    end
    element:setTexts(minute);
end

function fnGui:onCreateDayTimeScale(element)
    self.dts = element;
    local timeScale = {};

    for i = 1, #fastnight.timeScaling, 1 do
        timeScale[i] = ""..tostring(fastnight.timeScaling[i]).. "x";
    end
    element:setTexts(timeScale);
end

function fnGui:onCreateAutoDayTimeScale(element)
	self.adts = element
end

function fnGui:onCreateStartNightHour(element)
    self.snh = element;
    local hour = {};

    for i = 1, #fastnight.hourSteps, 1 do
        hour[i] = ""..tostring(fastnight.hourSteps[i]).. " h";
    end
    element:setTexts(hour);
end

function fnGui:onCreateStartNightMinute(element)
    self.snm = element;
    local minute = {};

    for i = 1, #fastnight.minuteSteps, 1 do
        minute[i] = ""..tostring(fastnight.minuteSteps[i]).. " m";
    end
    element:setTexts(minute);
end

function fnGui:onCreateNightTimeScale(element)
    self.nts = element;
    local timeScale = {};

    for i = 1, #fastnight.timeScaling, 1 do
        timeScale[i] = ""..tostring(fastnight.timeScaling[i]).. "x";
    end
    element:setTexts(timeScale);
end

function fnGui:onCreateAutoNightTimeScale(element)
	self.ants = element
end

function fnGui:setStartDayHour(indexHour)
    self.sdh:setState(indexHour, false);
end

function fnGui:setStartDayMinute(indexMinute)
    self.sdm:setState(indexMinute, false);
end

function fnGui:setDayTimeScale(indexTimeScale)
    self.dts:setState(indexTimeScale, false);
end

function fnGui:setAutoDayTimeScale(state)
    self.adts:setIsChecked(state);
end

function fnGui:setStartNightHour(indexHour)
    self.snh:setState(indexHour, false);
end

function fnGui:setStartNightMinute(indexMinute)
    self.snm:setState(indexMinute, false);
end

function fnGui:setNightTimeScale(indexTimeScale)
    self.nts:setState(indexTimeScale, false);
end

function fnGui:setAutoNightTimeScale(state)
    self.ants:setIsChecked(state);
end